searchNodes=[{"ref":"Numy.Enumy.html","title":"Numy.Enumy","type":"module","doc":"Extend Enum for homogeneous enumerables."},{"ref":"Numy.Enumy.html#all_floats?/1","title":"Numy.Enumy.all_floats?/1","type":"function","doc":"Check if all elements of a list are floats. Examples iex(10)&gt; import Numy.Enumy Numy.Enumy iex(11)&gt; all_floats?([1.1, 2.2, 3.3]) true iex(12)&gt; all_floats?([1.1, 2.2, 3]) false"},{"ref":"Numy.Enumy.html#all_integers?/1","title":"Numy.Enumy.all_integers?/1","type":"function","doc":"Check if all elements of a list are integers. Examples iex(1)&gt; import Numy.Enumy Numy.Enumy iex(2)&gt; all_integers?([1, 2, 3]) true iex(3)&gt; all_integers?([1.1, 2, 3]) false"},{"ref":"Numy.Enumy.html#all_numbers?/1","title":"Numy.Enumy.all_numbers?/1","type":"function","doc":""},{"ref":"Numy.Enumy.html#all_to_float/1","title":"Numy.Enumy.all_to_float/1","type":"function","doc":"Convert all numerical elements of a list to float type. Examples iex(13)&gt; all_to_float([1.1, 2.2, 3]) [1.1, 2.2, 3.0]"},{"ref":"Numy.Enumy.html#dot_product/2","title":"Numy.Enumy.dot_product/2","type":"function","doc":"The dot product is the sum of the products of the corresponding entries of the two sequences of numbers. Examples iex&gt; dot_product([1,2,3],[2,3,0]) 8 Benchmarks iex(1)&gt; fn1 = fn(v1,v2) -&gt; Numy.Enumy.dot_product(v1,v2) end iex(2)&gt; fn2 = fn(v1,v2) -&gt; Enum.zip(v1,v2) |&gt; Enum.map(fn {a,b} -&gt; a * b end) |&gt; ...(2)&gt; Enum.reduce(&amp;Kernel.+/2) end iex(3)&gt; fn3 = fn(v1,v2) -&gt; Enum.zip(v1,v2) |&gt; Flow.from_enumerable |&gt; ...(3)&gt; Flow.map(fn {a,b} -&gt; a * b end) |&gt; Enum.sum end iex(4)&gt; vec = Enum.to_list(1..999_000) iex(20)&gt; Benchee.run(%{&quot;1&quot; =&gt; fn -&gt; fn1.(vec,vec) end, ...(20)&gt; &quot;2&quot; =&gt; fn -&gt; fn2.(vec,vec) end, &quot;3&quot; =&gt; fn -&gt; fn3.(vec,vec) end}) Comparison: 1 22.58 3 0.58 - 38.84x slower +1.68 s 2 0.30 - 76.26x slower +3.33 s"},{"ref":"Numy.Enumy.html#mean/1","title":"Numy.Enumy.mean/1","type":"function","doc":"Get mean (average) of a sequence of numbers. Examples iex(14)&gt; mean([1,2,3,4,5,6,7,8,9]) 5.0"},{"ref":"Numy.Float.html","title":"Numy.Float","type":"module","doc":"Floating point number utilities."},{"ref":"Numy.Float.html#as_uint64/1","title":"Numy.Float.as_uint64/1","type":"function","doc":"Convert bit-by-bit 64-bit float to 64-bit integer."},{"ref":"Numy.Float.html#close?/4","title":"Numy.Float.close?/4","type":"function","doc":"Equality comparison for floating point numbers. Based on this blog post by Bruce Dawson."},{"ref":"Numy.Float.html#copysignbit/2","title":"Numy.Float.copysignbit/2","type":"function","doc":""},{"ref":"Numy.Float.html#from_number/1","title":"Numy.Float.from_number/1","type":"function","doc":""},{"ref":"Numy.Float.html#sign/1","title":"Numy.Float.sign/1","type":"function","doc":""},{"ref":"Numy.Float.html#signbit/1","title":"Numy.Float.signbit/1","type":"function","doc":"Return true if sign bit is 1 in the binary representation of the number. IEEE Long Real 64-bit binary format: 1 bit for the sign, 11 bits for the exponent, and 52 bits for the mantissa"},{"ref":"Numy.Float.html#ulp_diff/2","title":"Numy.Float.ulp_diff/2","type":"function","doc":"ULP difference."},{"ref":"Numy.Lapack.html","title":"Numy.Lapack","type":"module","doc":"NIF wrapper around LAPACK."},{"ref":"Numy.Lapack.html#__struct__/0","title":"Numy.Lapack.__struct__/0","type":"function","doc":"Numy.Lapack structure defines a tensor. Having tensor as NIF resource helps to bring computation to the data. iex&gt; tensor = %Numy.Lapack{shape: [3,2]}"},{"ref":"Numy.Lapack.html#assign/2","title":"Numy.Lapack.assign/2","type":"function","doc":""},{"ref":"Numy.Lapack.html#blas_dcopy/5","title":"Numy.Lapack.blas_dcopy/5","type":"function","doc":""},{"ref":"Numy.Lapack.html#blas_drotg/2","title":"Numy.Lapack.blas_drotg/2","type":"function","doc":""},{"ref":"Numy.Lapack.html#create_tensor/1","title":"Numy.Lapack.create_tensor/1","type":"function","doc":"Create new tensor NIF resource."},{"ref":"Numy.Lapack.html#data/2","title":"Numy.Lapack.data/2","type":"function","doc":""},{"ref":"Numy.Lapack.html#fill/2","title":"Numy.Lapack.fill/2","type":"function","doc":"Fill tensor with a scalar. Examples iex(1)&gt; tensor = Numy.Lapack.new_tensor([2,3]) iex(2)&gt; Numy.Lapack.fill(tensor, 3.14) iex(3)&gt; Numy.Lapack.data(tensor) [3.14, 3.14, 3.14, 3.14, 3.14, 3.14]"},{"ref":"Numy.Lapack.html#fill_tensor/2","title":"Numy.Lapack.fill_tensor/2","type":"function","doc":""},{"ref":"Numy.Lapack.html#generate_plane_rotation/2","title":"Numy.Lapack.generate_plane_rotation/2","type":"function","doc":"res = generate_plane_rotation(1,2) Keyword.fetch(res, :r | :z | :c | :s)"},{"ref":"Numy.Lapack.html#lapack_dgels/2","title":"Numy.Lapack.lapack_dgels/2","type":"function","doc":""},{"ref":"Numy.Lapack.html#load_nifs/0","title":"Numy.Lapack.load_nifs/0","type":"function","doc":"Callback on module&#39;s load. Loads NIF shared library."},{"ref":"Numy.Lapack.html#new_tensor/1","title":"Numy.Lapack.new_tensor/1","type":"function","doc":""},{"ref":"Numy.Lapack.html#nif_numy_version/0","title":"Numy.Lapack.nif_numy_version/0","type":"function","doc":"Get string with Elixir Numy version at the moment of NIF compilation. Use it for sanity check. Examples iex&gt; Numy.NIF.Lapack.numy_version &#39;0.1.0&#39;"},{"ref":"Numy.Lapack.html#solve_lls/2","title":"Numy.Lapack.solve_lls/2","type":"function","doc":""},{"ref":"Numy.Lapack.html#tensor_assign/2","title":"Numy.Lapack.tensor_assign/2","type":"function","doc":""},{"ref":"Numy.Lapack.html#tensor_data/2","title":"Numy.Lapack.tensor_data/2","type":"function","doc":""},{"ref":"Numy.Lapack.html#t:tensor_res/0","title":"Numy.Lapack.tensor_res/0","type":"opaque","doc":""},{"ref":"Numy.Tensor.html","title":"Numy.Tensor","type":"module","doc":"Numy.Tensor is a multi-dimentional matrix (sometimes caled ND-Array) contaning elements of a single data type."},{"ref":"Numy.Tensor.html#__struct__/0","title":"Numy.Tensor.__struct__/0","type":"function","doc":"Structure Tensor is opaque type for NIF structure. iex&gt; my_tensor = %Numy.Tensor{shape: [3,2]}"},{"ref":"Numy.Tensor.html#create/1","title":"Numy.Tensor.create/1","type":"function","doc":""},{"ref":"Numy.Tensor.html#load_nifs/0","title":"Numy.Tensor.load_nifs/0","type":"function","doc":"Callback on module&#39;s load. Loads NIF shared library."},{"ref":"Numy.Tensor.html#new/1","title":"Numy.Tensor.new/1","type":"function","doc":""},{"ref":"Numy.Tensor.html#nr_dimensions/1","title":"Numy.Tensor.nr_dimensions/1","type":"function","doc":"Examples iex(1)&gt; tensor_def = %Numy.Tensor{shape: [2,3]} #Numy.Tensor&lt;shape: [...], ...&gt; iex(2)&gt; tensor = Numy.Tensor.create(tensor_def) #Reference&lt;0.2043608959.3639214083.153022&gt; iex(3)&gt; Numy.Tensor.nr_dimensions(tensor) 2"},{"ref":"Numy.Tensor.html#t:tensor_res/0","title":"Numy.Tensor.tensor_res/0","type":"opaque","doc":""},{"ref":"Numy.Tz.html","title":"Numy.Tz","type":"protocol","doc":"Interface to Tensor."},{"ref":"Numy.Tz.html#assign/2","title":"Numy.Tz.assign/2","type":"function","doc":""},{"ref":"Numy.Tz.html#data/2","title":"Numy.Tz.data/2","type":"function","doc":""},{"ref":"Numy.Tz.html#ndim/1","title":"Numy.Tz.ndim/1","type":"function","doc":"Get number of dimensions Examples iex(1)&gt; tensor = Numy.Lapack.new_tensor([1,2,3,4,5]) iex(2)&gt; Numy.Tz.ndim(tensor) 5 iex(3)&gt; Numy.Tz.nelm(tensor) 120"},{"ref":"Numy.Tz.html#nelm/1","title":"Numy.Tz.nelm/1","type":"function","doc":"Get number of elements"},{"ref":"Numy.Tz.html#t:t/0","title":"Numy.Tz.t/0","type":"type","doc":""},{"ref":"Numy.Vector.html","title":"Numy.Vector","type":"module","doc":"Typical vector operations with [float] List. When list is long, we call NIF functions to speed up computation. Note: What we call &quot;vector&quot; here is just a list of numbers of type float, it is not a new type. Important: Make sure ALL elements of vector(s) have type float before calling functions of this module. NIF C functions assume all elements have type float, they will fail (usually with &quot;bad argument&quot; error) if some element is not float. Author: Igor Lesik 2019"},{"ref":"Numy.Vector.html#add/2","title":"Numy.Vector.add/2","type":"function","doc":"Examples iex(5)&gt; add([1.0,2.0,3.0],[2.0,3.0,4.0]) [3.0, 5.0, 7.0]"},{"ref":"Numy.Vector.html#dot_product/2","title":"Numy.Vector.dot_product/2","type":"function","doc":"The dot product is the sum of the products of the corresponding entries of the two sequences (vectors) of numbers. When vectors are long we call nif_dot_product. Warning: make sure all elements are float, use vec = Numy.Vector.from_list(your_list)"},{"ref":"Numy.Vector.html#element_multiply/2","title":"Numy.Vector.element_multiply/2","type":"function","doc":""},{"ref":"Numy.Vector.html#from_list/1","title":"Numy.Vector.from_list/1","type":"function","doc":"Convert list of numbers to list of floats (what we call vector)."},{"ref":"Numy.Vector.html#is_two_vectors_equal_length/2","title":"Numy.Vector.is_two_vectors_equal_length/2","type":"macro","doc":""},{"ref":"Numy.Vector.html#load_nifs/0","title":"Numy.Vector.load_nifs/0","type":"function","doc":"Callback on module&#39;s load. Loads NIF shared library."},{"ref":"Numy.Vector.html#mean_sq_err/2","title":"Numy.Vector.mean_sq_err/2","type":"function","doc":""},{"ref":"Numy.Vector.html#nif_dot_product/2","title":"Numy.Vector.nif_dot_product/2","type":"function","doc":"NIF implementation of dot product. Benchmarks iex(16)&gt; import Numy.Vector iex(17)&gt; vec = Numy.Vector.from_list(Enum.to_list(1..100)) iex(18)&gt; Benchee.run(%{&quot;elixir&quot; =&gt; fn -&gt; dot_product(vec, vec) end, \\ ...(18)&gt; &quot;C code&quot; =&gt; fn -&gt; nif_dot_product(vec, vec) end}) Comparison: C code 173.44 K elixir 149.06 K - 1.16x slower +0.94 μs iex(19)&gt; vec = Numy.Vector.from_list(Enum.to_list(1..1_000)) Comparison: C code 24.11 K elixir 14.77 K - 1.63x slower +26.25 μs iex(24)&gt; vec = Numy.Vector.from_list(Enum.to_list(1..99_000)) Comparison: C code 248.26 elixir 94.39 - 2.63x slower +6.57 ms"},{"ref":"Numy.Vector.html#root_mean_sq_err/2","title":"Numy.Vector.root_mean_sq_err/2","type":"function","doc":""},{"ref":"Numy.Vector.html#scale/2","title":"Numy.Vector.scale/2","type":"function","doc":"Multiply each element of vector by scalar constant factor. For long vectors scaling is done in parallel with Flow. Examples iex(2)&gt; scale([2.0,3.0,4.0], 0.5) [1.0, 1.5, 2.0] Benchmarks iex&gt; import Numy.Vector iex&gt; vec1 = Enum.to_list(1..1000) |&gt; from_list iex&gt; vec10 = Enum.to_list(1..10_000) |&gt; from_list iex&gt; vec99 = Enum.to_list(1..99_000) |&gt; from_list iex&gt; vec101 = Enum.to_list(1..101_000) |&gt; from_list iex&gt; vec999 = Enum.to_list(1..999_000) |&gt; from_list iex(7)&gt; Benchee.run(%{&quot;1&quot; =&gt; fn -&gt; scale(vec1, 0.5) end, ...(7)&gt; &quot;10&quot; =&gt; fn -&gt; scale(vec10, 0.5) end, ...(7)&gt; &quot;99&quot; =&gt; fn -&gt; scale(vec99, 0.5) end, ...(7)&gt; &quot;101&quot; =&gt; fn -&gt; scale(vec101, 0.5) end, ...(7)&gt; &quot;999&quot; =&gt; fn -&gt; scale(vec999, 0.5) end}) Name ips average deviation median 99th % 1 18824.26 0.0531 ms ±18.54% 0.0504 ms 0.0785 ms 10 1612.85 0.62 ms ±5.92% 0.61 ms 0.75 ms 99 118.20 8.46 ms ±10.34% 8.30 ms 13.34 ms 101 16.46 60.75 ms ±9.79% 59.47 ms 80.31 ms 999 1.68 593.90 ms ±8.80% 578.90 ms 704.34 ms"},{"ref":"Numy.Vector.html#subtract/2","title":"Numy.Vector.subtract/2","type":"function","doc":""},{"ref":"readme.html","title":"Numy","type":"extras","doc":"Numy Numy is LAPACK based scientific computing library."},{"ref":"readme.html#table-of-contents","title":"Numy - Table of contents","type":"extras","doc":"Example Comparison Installation Linear Algebra with LAPACK BLAS LAPACK"},{"ref":"readme.html#example","title":"Numy - Example","type":"extras","doc":"See this example in LAPACK reference documentation. iex(1)&gt; a = Numy.Lapack.new_tensor([3,5]) iex(2)&gt; Numy.Tz.assign(a, [ ...(2)&gt; [1,1,1], ...(2)&gt; [2,3,4], ...(2)&gt; [3,5,2], ...(2)&gt; [4,2,5], ...(2)&gt; [5,4,3]]) :ok iex(3)&gt; b = Numy.Lapack.new_tensor([2,5]) iex(4)&gt; Numy.Tz.assign(b, [ ...(4)&gt; [-10,-3], ...(4)&gt; [12,14], ...(4)&gt; [14,12], ...(4)&gt; [16,16], ...(4)&gt; [18,16]]) :ok iex(5)&gt; Numy.Lapack.solve_lls(a,b) 0 iex(6)&gt; solution = Numy.Lapack.data(b,2*3) [1.9999999999999982, 0.9999999999999983, 0.9999999999999991, 0.9999999999999997, 1.0000000000000024, 2.0000000000000018] iex(7)&gt; Numy.Float.close?(solution, [[2,1], [1,1], [1,2]]) true"},{"ref":"readme.html#comparison","title":"Numy - Comparison","type":"extras","doc":"The closest to Numy project (that I am aware of) is Matrex. Matrex is using immutable binaries and NIF code is calling enif_make_binary to return a result (matrix). enif_make_binary allocates memory space for the new binary. Numy on other hand is using mutable NIF resources and can reuse already allocated memory to store the result inside the context of NIF module."},{"ref":"readme.html#installation","title":"Numy - Installation","type":"extras","doc":"Ubuntu 18.04, sudo apt install liblapacke-dev gfortran. The package can be installed by adding numy to your list of dependencies in mix.exs: def deps do [ {:numy, &quot;~&gt; 0.1.1&quot;} ] end"},{"ref":"readme.html#linear-algebra-with-lapack","title":"Numy - Linear Algebra with LAPACK","type":"extras","doc":"BLAS See Quick Reference Guide to the BLAS. BLAS Level 1 Wrapper functionDirect functionDescription generate_plane_rotationblas_drotg BLAS Level 2 BLAS Level 3 LAPACK Wrapper functionDirect functionDescription solve_llslapack_dgels 0.1.0\"} ] end ``` Documentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc) and published on [HexDocs](https://hexdocs.pm). Once published, the docs can be found at [https://hexdocs.pm/numy](https://hexdocs.pm/numy). -->"}]